/*
 * gre/uiraster - GRE User Interface definitions for raster layer
 *
 * \if NODOC
 * $Id: uiraster.h_v 1.1 2011/09/16 20:56:44 mju Exp $
 *
 * $Log: uiraster.h_v $
 * Revision 1.1  2011/09/16 20:56:44  mju
 * Initial revision
 *
 * \endif
 */

#ifndef	INC_GRE_UIRASTER_H
#define	INC_GRE_UIRASTER_H

#ifndef	INC_GRE_LRRASTER_H
#include <gre/lrraster.h>
#endif

#ifdef USE_MGUI

#ifndef	INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif


namespace GRE {
//===================================================================================================================
//! Dialog for modifying layer display settings.
class LAYER_RASTER::DISPPARM::DLG : public MGUI::DLGSHELL {
	public:

		//! Constructor.
		DLG (
			LAYER_RASTER* LidarLayer,
			bool Include3D
			);

		//! Destructor.
		virtual ~DLG ();

		//! Get current LAYERDRAWFLAGS settings.
		LAYERDRAWFLAGS GetLayerDrawFlags (
			) const;

		//! Get current DISPPARM values.
		const LAYER_RASTER::DISPPARM& GetValues (
			) const;

		//! Set DISPPARM and LAYERDRAWFLAGS values.
		ERRVALUE SetValues (
			const LAYER_RASTER::DISPPARM& values,
			LAYERDRAWFLAGS LayerDrawFlags
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		LAYER_RASTER *m_layer;

		void ApplyChanges (bool ForceRedraw);

		virtual ERRVALUE v_CreateContent ();
		virtual void v_OnApply ();
		virtual void v_OnClose ();
		virtual void v_OnOK ();
		virtual void v_OnOpen ();

		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//===================================================================================================================
}	// End namespace GRE

#endif	// USE_MGUI

#endif	// INC_GRE_UIRASTER_H
