/**
 * \file mwizard.h <mi32/mwizard.h>
 * \brief Definitions for Mwizard functions
 *
 * \if NODOC
 * $Id: mwizard.h_v 1.8 2003/09/15 13:49:56 fileserver!dwilliss Exp $
 *
 * $Log: mwizard.h_v $
 * Revision 1.8  2003/09/15 13:49:56  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.7  2000/06/30 18:53:36  sparsons
 * Genitor documentation.
 *
 * Revision 1.6  2000/06/28 17:34:23  mju
 * Include stddefns so compiles in isolation.
 *
 * Revision 1.5  1999/04/08 19:25:27  mju
 * Add inclusion guards.
 *
 * \endif
**/

#ifndef	INC_MI32_MWIZARD_H
#define	INC_MI32_MWIZARD_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

#if defined(__cplusplus)
extern "C" {
#endif

//! Create a MicroImages wizard dialog.
int MwizardCreate (
	Widget parent,
	char *title,
	char *iconname,																//!< For future expansion
	Widget *retdialog,															//!< Dialog handle returned, unless NULL
	int (*PrevFrame)(Widget parent, void *HookData),					//! PrevFrame() - callback if user selected the "Prev" button 
	int (*NextFrame)(Widget parent, Widget *form, void *HookData),	//! NextFrame() - callback if user selected the "Next" button 
	void *hookdata,
	UINT32 flags
	);

//! Sets the "Next" button sensitive or not (changes state of user ability to "click" on the button).
void MwizardNextButtonSetSensitive (
	Widget dialog,
	int state
	);

//! Sets the help code string for the wizard dialog. 
void MwizardSetHelp (
	Widget dialog,
	char *helpcode
	);

//! Advances the wizard to the next panel.
void MwizardNextFrame (
	Widget widget
	);

#if defined(__cplusplus)
}
#endif

#define WIZARD_Done			1
#define WIZARD_LastFrame	2

#endif	//!<  INC_MI32_MWIZARD_H 
