/**
 * \file mi32/string.h
 * \brief C string function prototypes
 *
 * \if NODOC
 * $Id: string.h_v 1.3 2008/10/14 12:59:55 mju Exp $
 *
 * $Log: string.h_v $
 * Revision 1.3  2008/10/14 12:59:55  mju
 * Doxygen fix.
 *
 * Revision 1.2  2008/08/27 14:50:00  mju
 * Fix doxygen warning.
 *
 * Revision 1.1  2005/07/15 13:47:55  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_STRING_H
#define	INC_MI32_STRING_H

#ifndef	INC_STRING_H
#ifndef GENERATING_DOXYGEN_OUTPUT
#include <string.h>
#define	INC_STRING_H
#endif
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT

#if defined(__cplusplus)
extern "C" {
#endif

#if defined(WIN32)
#if __STDC__ && _MSC_VER >= 1200
// Microsoft renamed these because they're not "__STDC__"
#define stricmp	_stricmp
#define strlwr		_strlwr
#define strupr		_strupr
#define strnicmp	_strnicmp
#define strdup		_strdup
#endif

#else		// !WIN32

#if defined(SUN)
char *strdup (const char*);
#endif

char *strupr(char *);
char *strlwr(char *);

#if defined(UNIX)

#include <strings.h>

#if defined(__cplusplus)
inline int stricmp (
	const char*const s1, 
	const char*const s2
	) { return (strcasecmp(s1, s2)); }

inline int strnicmp (
	const char*const s1, 
	const char*const s2,
	int n
	) { return (strncasecmp(s1, s2, n)); }
#else
#define stricmp strcasecmp
#define strnicmp strncasecmp
#endif
	
#else 
int stricmp (const char*const, const char*const);
int strnicmp (const char*const, const char*const, int);
#endif

#endif	// !WIN32

#if defined(__cplusplus)
}	// Extern "C"
#endif

#endif	// GENERATING_DOXYGEN_OUTPUT

#endif	// INC_MI32_STRING_H
