/*****
* mi32/xmhtml.h : XmHTML Widget public header file
*
* This file Version	$Revision: 1.18 $
*
* Creation date:		Tue Nov 19 23:18:37 GMT+0100 1996
* Last modification: 	$Date: 2006/04/12 14:51:05 $
* By:					$Author: dwilliss $
* Current State:		$State: Exp $
*
* Author:				newt
* (C)Copyright 1995-1996 Ripley Software Development
* All Rights Reserved
*
* This file is part of the XmHTML Widget Library.
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the Free
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/

#ifndef INC_MI32_XMHTML_H
#define INC_MI32_XMHTML_H

/*****
* $Source: \\\\fileserver\\fileserver\\src\\tnt72\\incmi32\\xmhtml.h_v $
*****/
/*****
* ChangeLog 
* $Log: xmhtml.h_v $
* Revision 1.18  2006/04/12 14:51:05  dwilliss
* use win32 instead of winnt
*
* Revision 1.17  2005/03/31 16:57:22  fileserver!dwilliss
* Rename one of our types to MIUNICODE because it conflicted with a Microsoft #define
*
* Revision 1.16  2003/09/15 13:49:56  fileserver!dwilliss
* Doxygen
*
* Revision 1.15  2001/05/09 21:30:03  dwilliss
* oops.  typo
*
* Revision 1.14  2001/05/09 21:17:31  dwilliss
* Fix extern problem on Mac OS X
*
* Revision 1.13  2001/05/09 16:57:27  common
* try again
*
* Revision 1.12  2001/05/09 16:55:21  common
* fix for Mac OS X
*
* Revision 1.11  2000/08/16 17:37:24  msmith
* header documentation
*
* Revision 1.10  1999/03/24 17:55:41  dwilliss
* *** empty log message ***
*
* Revision 1.9  1999/02/18 21:04:42  dwilliss
* *** empty log message ***
*
* Revision 1.8  1999/02/18 20:56:42  dwilliss
* Need to export stuff on the Mac too, not just Windows
*
* Revision 1.7  1998/12/31 16:45:12  dwilliss
* Checking if CHAR is already typedef'd does no good if we never
* define the thing we're ifdef'ing
*
* Revision 1.6  1998/10/09 19:45:50  dwilliss
* added a protottype for a hack
*
 * Revision 1.5  1998/09/16  17:09:44  coffee!dwilliss
 * *** empty log message ***
 *
 * Revision 1.4  1998/09/16  17:05:33  coffee!dwilliss
 * .]
 *
 * Revision 1.3  1998/09/16  16:48:35  coffee!dwilliss
 * Update to 1.1.5
 *
* Revision 1.21  1998/04/27 06:56:31  newt
* Updated version number
*
* Revision 1.20  1998/04/04 06:27:53  newt
* XmHTML Beta 1.1.3
*
* Revision 1.19  1997/10/26 23:49:52  newt
* Moved internal symbol defines to XmHTMLP.h
*
* Revision 1.18  1997/10/23 00:24:44  newt
* XmHTML Beta 1.1.0 release
*
* Revision 1.17  1997/08/31 17:32:43  newt
* log edit
*
* Revision 1.16  1997/08/30 00:40:16  newt
* Changed proto's for XmHTMLImageReplace and XmHTMLImageUpdate. They now
* return an XmImageStatus instead of void.
*
* Revision 1.15  1997/08/01 12:54:55  newt
* Progressive image loading changes.
*
* Revision 1.14  1997/05/28 01:41:04  newt
* Added the XmHTMLImageGZFSupported, XmHTMLGIFtoGZF, XmHTMLGifReadOK and
* XmHTMLGifGetDataBlock convienience routines to convert GIF images to an
* alternate format. Added the XmHTMLAllocColor and XmHTMLFreeColor protos for
* easy color allocation. Modified the XmImageCreate routines to use a
* XmImageConfig structure.
*
* Revision 1.13  1997/04/29 14:22:35  newt
* Completely revised due to XmHTMLParserObject integration
*
* Revision 1.12  1997/04/03 05:31:30  newt
* XmHTMLFrameGetChild proto. XmIMAGE_SHARED_DATA option bit added.
*
* Revision 1.11  1997/03/28 07:06:14  newt
* XmNframeCallback, XmHTMLFrameCallbackStruct. XmHTMLParserCallback changes.
*
* Revision 1.10  1997/03/20 08:05:02  newt
* XmHTMLImageFreeImageInfo, XmNrepeatDelay
*
* Revision 1.9  1997/03/11 19:50:27  newt
* Changes in XmImageInfo; grouped and renamed convenience functions
*
* Revision 1.8  1997/03/04 18:45:55  newt
* XmNimagemapBoundingBoxForeground and XmCImagemapDrawBoundingBoxes 
* resources added
*
* Revision 1.7  1997/03/04 00:56:30  newt
* Delayed Image Loading: added the delayed field to the XmImageInfo structure. 
* Removed a number of obsolete defines
*
* Revision 1.6  1997/03/02 23:07:10  newt
* Image/Imagemap related changes. XmHTMLAnchorCallbackStruct changed
*
* Revision 1.5  1997/02/11 02:01:26  newt
* Added the XmNhandleShortTags resource
*
* Revision 1.4  1997/02/04 02:55:57  newt
* added the basefont element
*
* Revision 1.3  1997/01/09 06:55:53  newt
* expanded copyright marker
*
* Revision 1.2  1997/01/09 06:47:58  newt
* New resource: XmNparserCallback and corresponding error structure/defines
*
* Revision 1.1  1996/12/19 02:17:14  newt
* Initial Revision
*
*****/ 
/*****
* Public interfaces are listed at the end of this file
*****/

#ifndef _XmHTML_h_
#define _XmHTML_h_

#define XmHTMLVERSION	1
#define XmHTMLREVISION	1
#define XmHTMLUPDATE_LEVEL 5
#define XmHTMLVersion \
	(XmHTMLVERSION * 1000 + XmHTMLREVISION * 100 + XmHTMLUPDATE_LEVEL)

/* used by Imake to get Shared library version numbering */
#ifndef _LIBRARY

#define XmHTMLVERSION_STRING \
	"XmHTML Beta Version 1.1.5 (C)Ripley Software Development"

/* Required includes */
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <mi32/html.h>


#if defined(WIN32) || defined(USEDLLS)
#ifdef XMHTML_DLL
#if !defined(MAC_OSX)
#define XMHTMLEXPORT __declspec(dllexport)
#endif	//!<  !Mac OSX 
#else

#if defined(MAC_OSX)
#define XMHTMLEXPORT extern
#else
#define XMHTMLEXPORT extern __declspec(dllimport)
#endif	//!<  !Mac OSX 
#endif	//!<  XMHTML_DLL
#else
#define XMHTMLEXPORT extern
#endif

#ifndef XMHTMLEXPORT
#define XMHTMLEXPORT
#endif


#ifndef CHAR_ALREADY_TYPEDEFED
#define CHAR_ALREADY_TYPEDEFED
#ifdef CHAR
#undef CHAR
#endif
#ifdef MIUNICODE
typedef unsigned short CHAR;
#else
typedef unsigned char CHAR;
#endif //!<  MIUNICODE 
#endif //!<  CHAR_ALREADY_TYPEDEFED 

_XFUNCPROTOBEGIN		//!<  Should do the following but doesn't on sprite? 

#ifdef __cplusplus
extern "C" {
#endif

/* XmHTML type defines */
typedef struct _XmHTMLClassRec *XmHTMLWidgetClass;
typedef struct _XmHTMLRec *XmHTMLWidget;

/*****
* VMS works differently here: it defines externalref to globalref,
* so guard against incorrectly overriding the externaldef define.
*****/
#ifdef VMS
externalref WidgetClass xmHTMLWidgetClass;
#else
XMHTMLEXPORT WidgetClass xmHTMLWidgetClass;
#endif

/* XmHTML Widget subclassing macro */
#ifndef XmIsHTML
#define XmIsHTML(w)	XtIsSubclass(w, xmHTMLWidgetClass)
#endif //!<  XmIsHTML 

/********    Public Function Declarations    ********/

/*****
* Convenience/public functions
* There are six categories:
* - image related
* - anchor related
* - text related
* - tag analyzers
* - object related
* - functions that don't fit in any of the above three
*****/

/*****
* Image related convenience functions
*****/

//! XmHTML default image loading procedure.
//!
//! @return An XmImageInfo structure on success or NULL on failure
XMHTMLEXPORT XmImageInfo *XmHTMLImageDefaultProc (
	Widget w,									//!< Widget ID
	String file,								//!< full name and location of image to load
	unsigned char *buf,						//!< image data
	int size										//!< length of buf
	);

//! Determine the type of a given image.
//!
//! @return The image type if supported, IMAGE_UNKNOWN otherwise
XMHTMLEXPORT unsigned char XmHTMLImageGetType (
	String file,								//!< name of image file to check
	unsigned char *buf,
	int size
	);

//! Check if JPEG support is available (this is a compile time option).
//!
//! @return True if support is available.  False if not.
XMHTMLEXPORT Boolean XmHTMLImageJPEGSupported (
	void
	);

//! Check if PNG support is available.
//!
//! @return True if support is available.  False if not.
XMHTMLEXPORT Boolean XmHTMLImagePNGSupported (
	void
	);

//! Check if GZF support is available.
//!
//! @return True if support is available.  False if not.
XMHTMLEXPORT Boolean XmHTMLImageGZFSupported (
	void
	);

//! Replaces the XmImageInfo structure with a new one.
//!
//! @return XmIMAGE_ALMOST if replacing this image requires a recomputation
//! of the document layout,  XmIMAGE_OK if not and some other value upon error.
XMHTMLEXPORT XmImageStatus XmHTMLImageReplace (
	Widget w,									//!< XmHTMLWidget
	XmImageInfo *image,						//!< XmImageInfo structure to be replaced, must be known by XmHTML
	XmImageInfo *new_image					//!< new XmImageInfo structure
	);

//! Updates an image.
//!
//! @return XmIMAGE_ALMOST if updating this image requires a recomputation
//! of the document layout, XmIMAGE_OK if not and some other value upon error.
XMHTMLEXPORT XmImageStatus XmHTMLImageUpdate (
	Widget w,									//!< XmHTMLWidget
	XmImageInfo *image						//!< image info representing the image to be updated.
	);

//! Releases all allocated images and associated structures.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLImageFreeAllImages (
	Widget w										//!< XmHTMLWidget for which to free all images
	);

//! Add the given imagemap to an HTML widget.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLImageAddImageMap (
	Widget w,									//!< widget
	String image_map							//!< raw html data containinf the imagemap to parse
	);

//! Free the given XmImageInfo structure.
//!
//! @return nothing
XMHTMLEXPORT void	XmHTMLImageFreeImageInfo (
	Widget w,
	XmImageInfo *info							//!< image to free
	);

//! Returns the size of the given XmImageInfo structure.
//!
//! @return size of the given XmImageInfo structure
//! Note: This function is used both by us and the caching routines
XMHTMLEXPORT int XmHTMLImageGetImageInfoSize (
	XmImageInfo *info							//!< ptr to an XmImageInfo structure
	);

//! Suspend progressive image loading.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLImageProgressiveSuspend (
	Widget w
	);

//! Reactivate progressive image loading.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLImageProgressiveContinue (
	Widget w
	);

//! Terminate progressive image loading.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLImageProgressiveKill (
	Widget w
	);

/*****
* Special image functions
*****/

//! Creates and fills an image structure without bothering XmHTML.
//!
//! @return a newly created image, all fields filled.
//! Create and return a XmImage for use other than with XmHTML.
//! When width and height are non-zero, the image read is scaled to the specified
//! dimensions. 
XMHTMLEXPORT XmImage *XmImageCreate (
	Widget w,									//!< widget id
	String file,								//!< image filename
	Dimension width,							//!< requested image width
	Dimension height,							//!< requested image height
	XmImageConfig *config					//!< XmImage configuration
	);

//! Creates and fills and image structure without bothering XmHTML.
//!
//! @return a newly created image, all fields filled
//! Create an XmImage from the given XmImageInfo. When the image type is
//! IMAGE_UNKNOWN, but the url field represents a local file, this routine
//! calls XmImageCreate with the url field as the file argument.
//! Only honors the ImageFrameSelect, ImageCreateGC and ImageBackground
//! XmImageConfig flag and appropriate fields of that structure.
XMHTMLEXPORT XmImage *XmImageCreateFromInfo (
	Widget w,									//!< widget id
	XmImageInfo *info,						//!< XmImageInfo structure
	Dimension width,							//!< requested image width
	Dimension height,							//!< requested image height
	XmImageConfig *config					//!< XmImage configuration
	);

//! Completely destroys the given image.
//!
//! @return nothing
XMHTMLEXPORT void XmImageDestroy (
	XmImage *image								//!< image to destroy
	);

//! Sets the given image as the background image in the given destination drawable.
//!
//! @return -1 on error, 0 on success
//! Tiles "dest" with the given XmImage. Please note that "src" *must* have been
//! created with the ImageCreateGC flag, otherwise this function does nothing and
//! returns -1. Returns 0 upon success.
//! Internally, this routine is more or less a combination of XSetTile,
//! XSetTSOrigin and XFillRectangle in one.
//! Note: See XmHTML.c, routine PaintBackground for the how and why of this function.
XMHTMLEXPORT int XmImageSetBackgroundImage (
	XmImage *src,								//!< background image
	Drawable dest,								//!< destination drawable
	int src_x,									//!< x coordinate of the source rectangle (upper left corner)
	int src_y,									//!< y coordinate of the source rectangle (upper left corner)
	int width,									//!< width of the rectangle to be filled
	int height,									//!< height of the rectangle to be filled
	int dest_x,									//!< x coordinate of the destination drawable (upper left corner)
	int dest_y									//!< y coordinate of the destination drawable (upper left corner)
	);

//! Blits an XmImage to the given destination drawable.
//!
//! @return -1 on error, 0 on success
//! XCopyArea for an XmImage which also takes a possible clipmask into account.
//! Please note that "image" *must* have been created with the ImageCreateGC
//! flag, otherwise this function does nothing 
XMHTMLEXPORT int XmImageDrawImage (
	XmImage *image,							//!< image to be rendered
	Drawable dest,								//!< destination drawable
	int src_x,									//!< x coordinate of origin of image (upper left corner)
	int src_y,									//!< y coordinate of origin of image (upper left corner)
	int dest_x,									//!< x coordinate of destination drawable (upper left corner)
	int dest_y									//!< y coordinate of destination drawable (upper left corner)
	);

//! Export image to file.
//! 
//! @return false
//! Write an image to file. Returns False upon failure.
//! Saving an image in the GIF format is *not* possible due to Unisys's
//! stupid LZW licensing policy. Exporting an image as PNG, JPEG or GZF is only
//! possible if support for the required libraries has been compiled in.
XMHTMLEXPORT Boolean XmImageExport (
	XmImageInfo *info,
	String file,
	Dimension width,
	Dimension height,
	unsigned char type
	);

//! Converts a Compuserve gif image to a GZF image.
//!
//! return True when conversion was successfull.  False if something failed.
XMHTMLEXPORT Boolean XmHTMLGIFtoGZF (
	String infile,								//!< name of giffile
	unsigned char *buf,						//!< giffile data
	int size,									//!< size of buffer (if any)
	String outfile								//!< name of destination file
	);
//! Returns the internal id of an anchor.
//!
//! @return the id upon success, -1 if not found
//! Anchor related convenience functions
//! These routines can be used to jump to named anchors.
XMHTMLEXPORT int XmHTMLAnchorGetId (
	Widget w,									//!< XmHTMLWidget
	String anchor								//!< anchor to locate
	);

//! Moves the text with the current anchor on top.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLAnchorScrollToId (
	Widget w,									//!< XmHTMLWidget
	int anchor_id								//!< internal anchor id to scroll to
	);

//! Moves the text with the current anchor on top.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLAnchorScrollToName (
	Widget w,									//!< XmHTMLWidget
	String anchor								//!< anchor to scroll to
	);

//! Figure out if the given anchor is in the visible area.
//!
//! @return true when anchor is visible, false if not.
XMHTMLEXPORT Boolean XmHTMLAnchorVisibleByName (
	Widget w,									//!< XmHTMLWidget id
	String anchor								//!< NAME of anchor for which to test visibility
	);

//! Figure out if the given anchor is in the visible area.
//!
//! @return true when anchor is visible, false if not.
XMHTMLEXPORT Boolean XmHTMLAnchorVisibleById (
	Widget w,									//!< XmHTMLWidget id
	int anchor_id								//!< ID of anchor for which to test visibility
	);

//! Checks an HTML instance against a current href name.
//!
//! @return nothing
//! Checks an HTML instance against a current href name and alters any
//! matching anchors to visited and causes a refesh.
//! If visited is True, the matching anchor is rendered as visited. If it's
//! False, it will be rendered as not visited.
XMHTMLEXPORT void XmHTMLAnchorReEval (
	Widget w,									//!< html widget
	String href,								//!< current anchors reference
	Boolean visited							//!< href visited
	);

/*****
* Text related convenience functions
*****/

/* This macro sets the given text into a HTML widget */
#define XmHTMLTextSet (WIDGET,TEXT) XtVaSetValues((WIDGET), \
		XmNvalue, (TEXT), NULL)

//! Scrolls the widget to the given line number.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLTextScrollToLine (
	Widget w,									//!< widget to scroll
	int line										//!< line number to scroll to
	);

//! Sets the given text into the given HTML widget.
//!
//! @return nothing
//! clears any previous text and sets the new text
XMHTMLEXPORT void XmHTMLTextSetString (
	Widget w,									//!< XmHTMLWidget in question
	String text									//!< text to set
	);

//! Sets the given text into the given HTML widget.
//!
//! @return nothing
//! depending on current loading type, loads an entire document,
//! continue where we left off, append new text and then continue,
//! suspend or abort document load.
//!
//! same as XmHTMLTextSetString with one fundamental difference: text doesn't
//! have to be NULL terminated. The size of the input string is instead
//! given by len. If text is NULL or len is 0, the current contents are
//! cleared.
XMHTMLEXPORT void XmHTMLTextSetStringWithLength (
	Widget w,									//!< XmHTMLWidget in question
	String text,								//!< text to set, doesn't have to be NULL terminated
	size_t len									//!< size of input string.
	);

//! Returns a copy of the original, unmodified document.
//!
//! @return a *pointer* to the original text, or NULL when w isn't a subclass of XmHTML ot there wasn't a current document
XMHTMLEXPORT String XmHTMLTextGetSource (
	Widget w										//!< XmHTMLWidget in question
	);

//! Composes a text buffer consisting of the parser output.
//!
//! @return an allocated buffer containing the composed text upon success, NULL on failure
//! this return buffer is not necessarily equal to the original document
//! as the document verification and repair routines are capable of modifying the original rather heavily
//!
//! The return value from this function must be freed by the caller.
//! Typical use of this function is to set this buffer into the widget when
//! the parser failed to verify the document as it might well be that a next
//! parser pass on the original document does produce an HTML3.2 conforming
//! and verified document.
XMHTMLEXPORT String XmHTMLTextGetString (
	Widget w										//!< XmHTMLWidget in question
	);

//! Returns a formatted copy of the current document.
//!
//! @return a string which needs to be freed by the caller
XMHTMLEXPORT String XmHTMLTextGetFormatted (
	Widget w,									//!< XmHTMLWidget id
	unsigned char papertype,				//!< type of paper to use (any of the XmHTMLTEXT_PAPERSIZE enums)
	XmHTMLPaperSize *paperdef,				//!< size of paper for custom stuff, or default overrides
	unsigned char type,						//!< type of output wanted, plain, formatted or PS
	unsigned char PSoptions					//!< options to use when creating postscript output
	);

//! Returns a copy of the current document.
//!
//! @return NULL
//! (UNIMPLEMENTED, always returns NULL)
XMHTMLEXPORT String XmHTMLTextGetSelection (
	Widget w										//!< XmHTMLWidget id
	);

//! Clears the selection.
//!
//! @return nothing
//! (UNIMPLEMENTED)
XMHTMLEXPORT void XmHTMLTextClearSelection (
	Widget w,									//!< XmHTMLWidget id
	Time time
	);

//! Sets the selection between the specified positions.
//!
//! @return false
//! (UNIMPLEMENTED, always returns false)
XMHTMLEXPORT Boolean XmHTMLTextSetSelection (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLTextPosition first,				//!< first text position
	XmHTMLTextPosition last,				//!< last text position
	Time time
	);

//! Sets the highlight between the specified positions.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLTextSetHighlight (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLTextPosition first,				//!< first text position
	XmHTMLTextPosition last,				//!< last text position
	XmHighlightMode mode
	);

//! Copies text.
//!
//! @return false
//! (UNIMPLEMENTED, always returns false)
XMHTMLEXPORT Boolean XmHTMLTextCopy (
	Widget w,									//!< XmHTMLWidget id
	Time time
	);

//! Displays the position.
//!
//! @return false
//! (UNIMPLEMENTED, always returns false)
XMHTMLEXPORT Boolean XmHTMLTextShowPosition (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLTextPosition position			//!< text position
	);

//! Create a new Finder Context suitable for searching the contents of an HTML Widget.
//!
//! @return a new Finder context
XMHTMLEXPORT XmHTMLTextFinder XmHTMLTextFinderCreate (
	Widget w										//!< XmHTMLWidget id
	);

//! Destroys a finder context and frees any resources allocated.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLTextFinderDestroy (
	XmHTMLTextFinder finder					//!< finder to be destroyed
	);

//! Sets the search pattern in a finder.
//!
//! @return true when pattern was successfully set, false if not
XMHTMLEXPORT Boolean XmHTMLTextFinderSetPattern (
	XmHTMLTextFinder finder,				//!< finder to be updated
	String to_find								//!< test to be searched
	);

//! Allows users to fine-tune the pattern-compiler by providing their own regcomp flags.
//!
//! @return true when flags have been successfully changed, false if not
//! Note: Validity checking of the provided flags is rather impossible,
//! so the caller better be sure that the flags are correct or regcomp
//! will fail miserably.
XMHTMLEXPORT Boolean XmHTMLTextFinderSetPatternFlags (
	XmHTMLTextFinder finder,				//!< current Finder Context
	int flags,									//!< regcomp flags to be used
	Boolean ignore_case,						//!< if true, case is ignored when searching
	XmHTMLDirection direction				//!< search direction
	);

//! Returns error code of the last known regex error.
//!
//! @return error code of last known regex error
XMHTMLEXPORT int XmHTMLTextFinderGetError (
	XmHTMLTextFinder finder					//!< current Finder Context
	);

//! Returns a description of the last known regex error.
//!
//! @return a newly allocated string that must be freed by the caller
XMHTMLEXPORT String XmHTMLTextFinderGetErrorString (
	XmHTMLTextFinder finder					//!< current Finder Context
	);

//! Find the first appearance of the compiled pattern in the current text.
//!
//! @return XmREG_MATCH if a match was found, XmREG_NOMATCH if no match was found and XmREG_ERROR on error
XMHTMLEXPORT XmHTMLRegexStatus XmHTMLTextFindString (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLTextFinder finder					//!< current finder id
	);

//! Rewinds the finder to it's starting position and clears the pattern buffer.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLTextFinderReset (
	XmHTMLTextFinder finder					//!< finder to be reset
	);

//! Determines if there is a matching word in the specified range.
//!
//! @return true if a matching word is found, false if not
XMHTMLEXPORT Boolean XmHTMLTextFindToPosition (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLTextFinder finder,				//!< current finder id
	XmHTMLTextPosition *start,				//!< starting position
	XmHTMLTextPosition *end					//!< ending position
	);

/*****
* Tag analyzers.
* These routines allow you to filter values out of the attributes 
* attached to a HTML element.
*****/

//! Retrieves the numerical value of the given tag.
//!
//! @return if tag exists, the value of this tag, def otherwise
XMHTMLEXPORT int XmHTMLTagGetNumber (
	String attributes,						//!< attributes from an HTML element
	String tag,									//!< tag to look for
	int default_value							//!< default value if tag is not found
	);

//! Retrieves the numerical value of the given tag.
//!
//! @return if tag exists, the value of this tag, def otherwise
//! If the returned no is negative, the specified value was a
//! relative number.  Otherwise it's an absolute number.
XMHTMLEXPORT int XmHTMLTagCheckNumber (
	String attributes,						//!< attributes from an HTML element
	String tag,									//!< tag to look for
	int default_value							//!< default value if tag is not found
	);

//! Looks for the specified tag in the given list of attributes.
//!
//! @return if tag exists, the vaue of this tag, NULL otherwise
//! return value is always malloc'd; caller must free it
XMHTMLEXPORT String XmHTMLTagGetValue (
	String attributes,						//!< attributes from an HTML element
	String tag									//!< tag to look for
	);

//! Check whether the given tag exists in the attributes of an HTML element.
//!
//! @return true if tag is found, false otherwise
XMHTMLEXPORT Boolean XmHTMLTagCheck (
	String attributes,						//!< attributes from an HTML element
	String tag									//!< tag to look for
	);

//! Checks whether the specified tag in the given list of attributes has a certain value.
//!
//! @return true if tag exists and has the correct value, false otherwise
XMHTMLEXPORT Boolean XmHTMLTagCheckValue (
	String attributes,						//!< attributes from an HTML element
	String tag,									//!< tag to look for
	String check								//!< value to check
	);

#ifndef GENERATING_DOXYGEN_OUTPUT

/*****
* Object related convenience functions.
* These functions allow one to define custom HTML elements to XmHTML.
*****/

/* define a new element to the HTML parser */
XMHTMLEXPORT XmHTMLElementId XmHTMLObjectDefine (
	String element,
	Boolean terminated,
	unsigned long attribute_flags,
	XtPointer user_data
	);

/* undefine a previously defined element */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectUndefine (
	XmHTMLElementId element_id
	);

/* reconfigure the given object (change position and/or size) */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectReconfigure (
	Widget w,
	XmHTMLObjectId object_id,
	int x,
	int y,
	Dimension width, 
	Dimension height
	);

/* show/hide the given object */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectShow (
	Widget w,
	XmHTMLObjectId object_id,
	Boolean show
	);

/* raise the given object from the currently displayed document */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectRaise (
	Widget w,
	XmHTMLObjectId object_id
	);

/* lower the given object into the currently displayed document */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectLower (
	Widget w,
	XmHTMLObjectId object_id
	);

/* Create an external object corresponding to a previously defined element */
XMHTMLEXPORT XmHTMLObjectId XmHTMLObjectCreate (
	XmHTMLElementId element_id
	);

/* Destroy an external object */
XMHTMLEXPORT void XmHTMLObjectDestroy (
	XmHTMLObjectId object_id
	);

/* register an external object for use with XmHTML */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectRegister (
	Widget w,
	XmHTMLObjectId object_id
	);

/* unregister a previously registered object from XmHTML */
XMHTMLEXPORT XmHTMLObjectStatus XmHTMLObjectUnregister (
	Widget w,
	XmHTMLObjectId object_id
	);

/* fetch the element data from the given object */
XMHTMLEXPORT XmHTMLElementId XmHTMLObjectGetElement (
	Widget w,
	XmHTMLObjectId object_id
	);

#endif //!< GENERATING_DOXYGEN_OUTPUT

/*****
* Miscelleneous convenience functions
*****/

//! Returns the version number of XmHTML.
//!
//! @return version number of this library
XMHTMLEXPORT int XmHTMLGetVersion (
	void
	);

//! Tries to figure out what type of url the given href is.
//!
//! @return type of url when we know it, ANCHOR_UNKNOWN otherwise
XMHTMLEXPORT URLType XmHTMLGetURLType (
	String href									//!< url specification
	);

//! Returns the value of the \<title\>\</title\> element.
//!
//! @return value of the title upon success, NULL on failure
XMHTMLEXPORT String XmHTMLGetTitle (
	Widget w										//!< XmHTMLWidget in question
	);

//! Retrives the contents of an image and/or anchor ath the given cursor position.
//!
//! @return a filled XmHTMLInfoStructure when the pointer whas pressed on an image and/or anchor, NULL if not
//! Note: The return value, nor one of its members may be free by the caller.
XMHTMLEXPORT XmHTMLInfoStructure *XmHTMLXYToInfo (
	Widget w,									//!< XmHTMLWidget id
	int x,										//!< x-location of pointer, relative to left side of workArea
	int y											//!< y-location of pointer, relative to top side of workArea
	);

//! Returns a list of all images and anchors found in the currently displayed page.
//!
//! @return a new XmHTMLDocumentInfo structure on success or NULL on failure
XMHTMLEXPORT XmHTMLDocumentInfo *XmHTMLGetDocumentInfo (
	Widget w										//!< XmHTMLWidget id
	);

//! Frees an XmHTMLDocumentInfo structure
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLFreeDocumentInfo (
	XmHTMLDocumentInfo *doc_info			//!< structure to be freed
	);

//! Fills the given HeadAttributes with the requested document.
//!
//! @return true when a \<head\>\</head\> block is present, false if not
//! When mask_bits
//! only contains HeadClear, the given attribute structure is wiped clean and
//! this function will return False immediatly.
//! The only exception concerns the \<!DOCTYPE\> tag and the HeadDocType mask bit:
//! if this bit is set, the value of this tag is returned whether or not a
//! head is present.
XMHTMLEXPORT Boolean XmHTMLGetHeadAttributes (
	Widget w,									//!< XmHTMLWidget id
	XmHTMLHeadAttributes *head,			//!< structure to fill
	unsigned char mask_bits					//!< indicates what members to fill
	);

//! Returns the Widget id of a frame child given it's name.
//!
//! @return if found, the widget id of the requested fram, NULL otherwise
XMHTMLEXPORT Widget XmHTMLFrameGetChild (
	Widget w,									//!< XmHTMLWidget
	String name									//!< name of frame to locate
	);

//! Creates an XmHTML widget.
//!
//! @return a newly created widget
//! This routine exits if parent is NULL or a subclass
XMHTMLEXPORT Widget XmCreateHTML (
	Widget parent,								//!< widget to act as parent for this new XmHTMLWidget
	String name,								//!< name for the new widget
	ArgList arglist,							//!< arguments for this new XmHTMLWidget
	Cardinal argcount							//!< number of arguments
	);

//! Forces a layout recomputation of the currently loaded document.
//!
//! @return nothing
//! Note: this function is mostly usedful in combination with the
//! image updating and/or replacing routines.
XMHTMLEXPORT void XmHTMLRedisplay (
	Widget w										//!< Widget for which to redo layout computation
	);

//! Returns info about the font cache for display of the given widget.
//!
//! @return font cache info
XMHTMLEXPORT XmHTMLFontCacheInfo *XmHTMLGetFontCacheInfo (
	Widget w										//!< Widget for which to get font cache info
	);

//! Frees the given font cache info.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLFreeFontCacheInfo (
	XmHTMLFontCacheInfo *info				//!< font cache info to free
	);

//! Allocates the named color and takes the XmNmaxImageColors resource into account.
//!
//! @return allocated pixel upon success or def_pixel upon failure
XMHTMLEXPORT Pixel XmHTMLAllocColor (
	Widget w,									//!< XmHTMLWidget id
	String color,								//!< colorname, either symbolic or an RGB triplet
	Pixel def_pixel							//!< pixel to return when allocation of "color fails
	);

//! Releases an allocated pixel.
//!
//! @return nothing
XMHTMLEXPORT void XmHTMLFreeColor (
	Widget w,									//!< XmHTMLWidget id
	Pixel pixel									//!< pixel to be freed
	);

//! Function that won't be needed once we can specify a tka as a resource
//!
//! @return nothing
XMHTMLEXPORT void _XmHTMLSetTkaOverrideFunc (
	void(*)(void*,void*),
	void*
	);

#ifdef __cplusplus
}
#endif

_XFUNCPROTOEND

#endif //!<  _LIBRARY 

/* Don't add anything after this endif! */
#endif //!<  _XmHTML_h_ 

#endif  // INC_MI32_XMHTML_H
