/**
 * \file rvc/uidlgdbfieldpicklist.h
 * \brief RVC::UI::DLG_DB_FIELD_PICKLIST definitions
 *
 * \if NODOC
 * $Id: uidlgdbfieldpicklist.h_v 1.9 2010/02/22 18:51:47 mju Exp $
 *
 * $Log: uidlgdbfieldpicklist.h_v $
 * Revision 1.9  2010/02/22 18:51:47  mju
 * Change so specify table/field "for" when create.
 *
 * Revision 1.8  2010/02/22 15:10:03  mju
 * Add settings::v_getObjNameBase.
 *
 * Revision 1.7  2010/02/19 22:40:14  mju
 * Make settings public and use form::settings directly.
 *
 * Revision 1.6  2009/08/21 13:35:52  mju
 * Use form_db_field_picklist.
 *
 * Revision 1.5  2009/01/20 16:42:17  mju
 * Add members so can have sample with multistyle.
 *
 * Revision 1.4  2008/09/25 19:23:21  mju
 * Add onGridRightClick.
 *
 * Revision 1.3  2008/09/25 15:10:43  mju
 * Move some common stuff to base class.
 *
 * Revision 1.2  2008/09/22 19:40:36  mju
 * Add m_allowNone.
 *
 * Revision 1.1  2008/09/22 19:00:06  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_RVC_UIDLGDBFIELDPICKLIST_H
#define	INC_RVC_UIDLGDBFIELDPICKLIST_H

#ifndef	INC_RVC_UIDLGDBFIELDVALUE_H
#include <rvc/uidlgdbfieldvalue.h>
#endif

#ifndef	INC_RVC_UIFORMDBFIELDPICKLIST_H
#include <rvc/uiformdbfieldpicklist.h>
#endif

namespace RVC {
namespace UI {
//=====================================================================================================================

class DLG_DB_FIELD_PICKLIST : public DLG_DB_FIELD_VALUE {
	public:

		//! Constructor.
		DLG_DB_FIELD_PICKLIST (
			);

		//! Destructor.
		virtual ~DLG_DB_FIELD_PICKLIST ();

		class SETTINGS : public DLG_DB_FIELD_VALUE::SETTINGS {
			public:
				SETTINGS ();
				const FORM_DB_FIELD_PICKLIST::SETTINGS& GetFormSettings (
					) const { return (m_FormSettings); }
				const LPOINT2D& GetPosition (
					) const { return (m_Position); }
				bool HasPlacement (
					) const { return (m_Position.x >= 0 && m_Position.y >= 0); }
				void SetFormSettings (
					const FORM_DB_FIELD_PICKLIST::SETTINGS& FormSettings
					);
				void SetPosition (
					INT32 x,
					INT32 y
					) { if (x != m_Position.x || y != m_Position.y) { SetChanged(); m_Position.x = x; m_Position.y = y; } }
			private:
				#ifndef GENERATING_DOXYGEN_OUTPUT
				typedef SETTINGS THISCLASS;
				FORM_DB_FIELD_PICKLIST::SETTINGS m_FormSettings;
				LPOINT2D m_Position;

				virtual const char* v_GetObjNameBase () const;
				virtual const SERIALIZERITEM* v_SerialGetItemDef () const;
				#endif
			};

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		typedef DLG_DB_FIELD_PICKLIST THISCLASS;

		SETTINGS m_Settings;
		RVC::UI::FORM_DB_FIELD_PICKLIST m_FormPick;
		bool m_AllowNone;

		// SHELL/DLGSHELL overrides.
		virtual ERRVALUE v_CreateContent ();

		// DLG_DB_FIELD_VALUE overrides.
		virtual ERRVALUE v_GetValue (RVC::DBTABLE::RECORD& record);
		virtual ERRVALUE v_Setup (const RVC::DBTABLE& ObjTable);
		virtual ERRVALUE v_SetValue (const RVC::DBTABLE::RECORD& record);
		virtual void v_UpdateSettings ();
		#endif
	};
//=====================================================================================================================
}	// End namespace UI
}	// End namespace RVC

#endif	// INC_RVC_UIDLGDBFIELDPICKLIST_H

