/**
 * \file spatmod/metadatacontent.h
 * \brief Spatial Modelling metadata content flags
 *
 * \if NODOC
 * $Id: metadatacontent.h_v 1.2 2007/01/04 18:00:03 mju Exp $
 *
 * $Log: metadatacontent.h_v $
 * Revision 1.2  2007/01/04 18:00:03  mju
 * Fix comment at end.
 *
 * Revision 1.1  2007/01/03 21:03:48  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_SPATMOD_METADATACONTENT_H
#define	INC_SPATMOD_METADATACONTENT_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

namespace SPATMOD {

//! Enumeratin of metadata content selections
enum METADATACONTENT {
	METADATACONTENT_Source_Name =		0x0000,
	METADATACONTENT_Source_Typical =	0x0001,
	METADATACONTENT_Source_Maximal = 0x0003,
	METADATACONTENT_Source_MASK =		0x0003,

	METADATACONTENT_Filter_None =		0x0000,
	METADATACONTENT_Filter_Name =		0x0010,
	METADATACONTENT_Filter_Parms =	0x0020,
	METADATACONTENT_Filter_Maximal =	0x0030,
	METADATACONTENT_Filter_MASK =		0x0030,

	METADATACONTENT_All =				(METADATACONTENT_Source_Maximal + METADATACONTENT_Filter_Maximal)
	};

#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_BITWISE(METADATACONTENT)
#endif

}	// End namespace SPATMOD

#endif	// INC_SPATMOD_METADATACONTENT_H
