/* $Xorg: Converters.h,v 1.4 2000/08/17 19:45:59 cpqbld Exp $ */

/*
 
Copyright 1988, 1998  The Open Group

All Rights Reserved.

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
OPEN GROUP BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of The Open Group shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from The Open Group.

*/

/* $XFree86: xc/lib/Xmu/Converters.h,v 1.5 2001/01/17 19:42:53 dawes Exp $ */

/*
 * The interfaces described by this header file are for miscellaneous utilities
 * and are not part of the Xlib standard.
 */

#ifndef _XMU_STRCONVERT_H_
#define _XMU_STRCONVERT_H_

#include <X11/Intrinsic.h>
#include <X11/Xfuncproto.h>

#ifdef WIN32
#ifdef XMUDLL
#define XMUDLLEXPORT _declspec(dllexport)
#else
#define XMUDLLEXPORT _declspec(dllimport)
#endif
#else
#define XMUDLLEXPORT extern
#endif

_XFUNCPROTOBEGIN

XMUDLLEXPORT void XmuCvtFunctionToCallback
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

#define XtNbackingStore "backingStore"
#define XtCBackingStore "BackingStore"
#define XtRBackingStore "BackingStore"
#define XtEnotUseful "notUseful"
#define XtEwhenMapped "whenMapped"
#define XtEalways "always"
#define XtEdefault "default"
XMUDLLEXPORT void XmuCvtStringToBackingStore
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

XMUDLLEXPORT Boolean XmuCvtBackingStoreToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

XMUDLLEXPORT void XmuCvtStringToCursor
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

#define XtRColorCursor "ColorCursor"
#define XtNpointerColor "pointerColor"
#define XtNpointerColorBackground "pointerColorBackground"
XMUDLLEXPORT Boolean XmuCvtStringToColorCursor
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

typedef int XtGravity;

#ifndef XtRGravity
#define XtRGravity "Gravity"
#endif
#define XtEForget "forget"
#define XtENorthWest "northwest"
#define XtENorth "north"
#define XtENorthEast "northeast"
#define XtEWest "west"
#define XtECenter "center"
#define XtEEast "east"
#define XtESouthWest "southwest"
#define XtESouth "south"
#define XtESouthEast "southeast"
#define XtEStatic "static"
#define XtEUnmap "unmap"
XMUDLLEXPORT void XmuCvtStringToGravity
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

XMUDLLEXPORT Boolean XmuCvtGravityToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

typedef enum {
    XtJustifyLeft,       /* justify text to left side of button   */
    XtJustifyCenter,     /* justify text in center of button      */
    XtJustifyRight       /* justify text to right side of button  */
} XtJustify;
#ifndef XtRJustify
#define XtRJustify "Justify"
#endif
#define XtEleft "left"
#define XtEcenter "center"
#define XtEright "right"
#define XtEtop "top"
#define XtEbottom "bottom"
XMUDLLEXPORT void XmuCvtStringToJustify
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

XMUDLLEXPORT Boolean XmuCvtJustifyToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

#define XtRLong "Long"
XMUDLLEXPORT void XmuCvtStringToLong
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );
XMUDLLEXPORT Boolean XmuCvtLongToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

typedef enum {
  XtorientHorizontal,
  XtorientVertical
} XtOrientation;
XMUDLLEXPORT void XmuCvtStringToOrientation
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

XMUDLLEXPORT Boolean XmuCvtOrientationToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

XMUDLLEXPORT void XmuCvtStringToBitmap
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

#define XtRShapeStyle "ShapeStyle"
#define XtERectangle "Rectangle"
#define XtEOval "Oval"
#define XtEEllipse "Ellipse"
#define XtERoundedRectangle "RoundedRectangle"

#define XmuShapeRectangle 1
#define XmuShapeOval 2
#define XmuShapeEllipse 3
#define XmuShapeRoundedRectangle 4

XMUDLLEXPORT Boolean XmuCvtStringToShapeStyle
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

XMUDLLEXPORT Boolean XmuCvtShapeStyleToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal,
 XtPointer		*converter_data
 );

XMUDLLEXPORT Boolean XmuReshapeWidget
(
 Widget			w,
 int			shape_style,
 int			corner_width,
 int			corner_height
 );

XMUDLLEXPORT void XmuCvtStringToWidget
(
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValuePtr		fromVal,
 XrmValuePtr		toVal
 );

XMUDLLEXPORT Boolean XmuNewCvtStringToWidget
(
 Display		*display,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValue		*fromVal,
 XrmValue		*toVal,
 XtPointer		*converter_data
 );

XMUDLLEXPORT Boolean XmuCvtWidgetToString
(
 Display		*dpy,
 XrmValue		*args,
 Cardinal		*num_args,
 XrmValue		*fromVal,
 XrmValue		*toVal,
 XtPointer		*converter_data
 );

_XFUNCPROTOEND

#endif /* _XMU_STRCONVERT_H_ */
